/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.primitivetypes;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.emftext.language.primitivetypes.PrimitivetypesFactory
 * @model kind="package"
 * @generated
 */
public interface PrimitivetypesPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "primitivetypes";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.emftext.org/language/primitivetypes";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "primitivetypes";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  PrimitivetypesPackage eINSTANCE = org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl.init();

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.EStringElementImpl <em>EString Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.EStringElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEStringElement()
   * @generated
   */
  int ESTRING_ELEMENT = 0;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ESTRING_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EString Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ESTRING_ELEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.EBooleanElementImpl <em>EBoolean Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.EBooleanElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEBooleanElement()
   * @generated
   */
  int EBOOLEAN_ELEMENT = 1;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EBOOLEAN_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EBoolean Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EBOOLEAN_ELEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.ECharElementImpl <em>EChar Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.ECharElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getECharElement()
   * @generated
   */
  int ECHAR_ELEMENT = 2;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECHAR_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EChar Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECHAR_ELEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.EFloatElementImpl <em>EFloat Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.EFloatElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEFloatElement()
   * @generated
   */
  int EFLOAT_ELEMENT = 3;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EFLOAT_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EFloat Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EFLOAT_ELEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.EDoubleElementImpl <em>EDouble Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.EDoubleElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEDoubleElement()
   * @generated
   */
  int EDOUBLE_ELEMENT = 4;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EDOUBLE_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EDouble Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EDOUBLE_ELEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.EIntElementImpl <em>EInt Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.EIntElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEIntElement()
   * @generated
   */
  int EINT_ELEMENT = 5;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EINT_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EInt Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EINT_ELEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.primitivetypes.impl.EBigIntegerElementImpl <em>EBig Integer Element</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.primitivetypes.impl.EBigIntegerElementImpl
   * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEBigIntegerElement()
   * @generated
   */
  int EBIG_INTEGER_ELEMENT = 6;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EBIG_INTEGER_ELEMENT__VALUE = 0;

  /**
   * The number of structural features of the '<em>EBig Integer Element</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int EBIG_INTEGER_ELEMENT_FEATURE_COUNT = 1;


  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.EStringElement <em>EString Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EString Element</em>'.
   * @see org.emftext.language.primitivetypes.EStringElement
   * @generated
   */
  EClass getEStringElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.EStringElement#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.EStringElement#getValue()
   * @see #getEStringElement()
   * @generated
   */
  EAttribute getEStringElement_Value();

  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.EBooleanElement <em>EBoolean Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EBoolean Element</em>'.
   * @see org.emftext.language.primitivetypes.EBooleanElement
   * @generated
   */
  EClass getEBooleanElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.EBooleanElement#isValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.EBooleanElement#isValue()
   * @see #getEBooleanElement()
   * @generated
   */
  EAttribute getEBooleanElement_Value();

  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.ECharElement <em>EChar Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EChar Element</em>'.
   * @see org.emftext.language.primitivetypes.ECharElement
   * @generated
   */
  EClass getECharElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.ECharElement#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.ECharElement#getValue()
   * @see #getECharElement()
   * @generated
   */
  EAttribute getECharElement_Value();

  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.EFloatElement <em>EFloat Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EFloat Element</em>'.
   * @see org.emftext.language.primitivetypes.EFloatElement
   * @generated
   */
  EClass getEFloatElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.EFloatElement#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.EFloatElement#getValue()
   * @see #getEFloatElement()
   * @generated
   */
  EAttribute getEFloatElement_Value();

  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.EDoubleElement <em>EDouble Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EDouble Element</em>'.
   * @see org.emftext.language.primitivetypes.EDoubleElement
   * @generated
   */
  EClass getEDoubleElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.EDoubleElement#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.EDoubleElement#getValue()
   * @see #getEDoubleElement()
   * @generated
   */
  EAttribute getEDoubleElement_Value();

  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.EIntElement <em>EInt Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EInt Element</em>'.
   * @see org.emftext.language.primitivetypes.EIntElement
   * @generated
   */
  EClass getEIntElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.EIntElement#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.EIntElement#getValue()
   * @see #getEIntElement()
   * @generated
   */
  EAttribute getEIntElement_Value();

  /**
   * Returns the meta object for class '{@link org.emftext.language.primitivetypes.EBigIntegerElement <em>EBig Integer Element</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EBig Integer Element</em>'.
   * @see org.emftext.language.primitivetypes.EBigIntegerElement
   * @generated
   */
  EClass getEBigIntegerElement();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.primitivetypes.EBigIntegerElement#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see org.emftext.language.primitivetypes.EBigIntegerElement#getValue()
   * @see #getEBigIntegerElement()
   * @generated
   */
  EAttribute getEBigIntegerElement_Value();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  PrimitivetypesFactory getPrimitivetypesFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.EStringElementImpl <em>EString Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.EStringElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEStringElement()
     * @generated
     */
    EClass ESTRING_ELEMENT = eINSTANCE.getEStringElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ESTRING_ELEMENT__VALUE = eINSTANCE.getEStringElement_Value();

    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.EBooleanElementImpl <em>EBoolean Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.EBooleanElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEBooleanElement()
     * @generated
     */
    EClass EBOOLEAN_ELEMENT = eINSTANCE.getEBooleanElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EBOOLEAN_ELEMENT__VALUE = eINSTANCE.getEBooleanElement_Value();

    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.ECharElementImpl <em>EChar Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.ECharElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getECharElement()
     * @generated
     */
    EClass ECHAR_ELEMENT = eINSTANCE.getECharElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ECHAR_ELEMENT__VALUE = eINSTANCE.getECharElement_Value();

    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.EFloatElementImpl <em>EFloat Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.EFloatElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEFloatElement()
     * @generated
     */
    EClass EFLOAT_ELEMENT = eINSTANCE.getEFloatElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EFLOAT_ELEMENT__VALUE = eINSTANCE.getEFloatElement_Value();

    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.EDoubleElementImpl <em>EDouble Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.EDoubleElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEDoubleElement()
     * @generated
     */
    EClass EDOUBLE_ELEMENT = eINSTANCE.getEDoubleElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EDOUBLE_ELEMENT__VALUE = eINSTANCE.getEDoubleElement_Value();

    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.EIntElementImpl <em>EInt Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.EIntElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEIntElement()
     * @generated
     */
    EClass EINT_ELEMENT = eINSTANCE.getEIntElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EINT_ELEMENT__VALUE = eINSTANCE.getEIntElement_Value();

    /**
     * The meta object literal for the '{@link org.emftext.language.primitivetypes.impl.EBigIntegerElementImpl <em>EBig Integer Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.primitivetypes.impl.EBigIntegerElementImpl
     * @see org.emftext.language.primitivetypes.impl.PrimitivetypesPackageImpl#getEBigIntegerElement()
     * @generated
     */
    EClass EBIG_INTEGER_ELEMENT = eINSTANCE.getEBigIntegerElement();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute EBIG_INTEGER_ELEMENT__VALUE = eINSTANCE.getEBigIntegerElement_Value();

  }

} //PrimitivetypesPackage
