/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.templateconcepts.call;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.emftext.language.templateconcepts.call.CallFactory
 * @model kind="package"
 * @generated
 */
public interface CallPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "call";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.emftext.org/language/templateconcepts/call";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "call";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  CallPackage eINSTANCE = org.emftext.language.templateconcepts.call.impl.CallPackageImpl.init();

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.call.impl.TemplateCallImpl <em>Template Call</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.call.impl.TemplateCallImpl
   * @see org.emftext.language.templateconcepts.call.impl.CallPackageImpl#getTemplateCall()
   * @generated
   */
  int TEMPLATE_CALL = 0;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE_CALL__TARGET = 0;

  /**
   * The feature id for the '<em><b>Parameter Model</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE_CALL__PARAMETER_MODEL = 1;

  /**
   * The number of structural features of the '<em>Template Call</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE_CALL_FEATURE_COUNT = 2;


  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.call.TemplateCall <em>Template Call</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Template Call</em>'.
   * @see org.emftext.language.templateconcepts.call.TemplateCall
   * @generated
   */
  EClass getTemplateCall();

  /**
   * Returns the meta object for the reference '{@link org.emftext.language.templateconcepts.call.TemplateCall#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target</em>'.
   * @see org.emftext.language.templateconcepts.call.TemplateCall#getTarget()
   * @see #getTemplateCall()
   * @generated
   */
  EReference getTemplateCall_Target();

  /**
   * Returns the meta object for the reference '{@link org.emftext.language.templateconcepts.call.TemplateCall#getParameterModel <em>Parameter Model</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Parameter Model</em>'.
   * @see org.emftext.language.templateconcepts.call.TemplateCall#getParameterModel()
   * @see #getTemplateCall()
   * @generated
   */
  EReference getTemplateCall_ParameterModel();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  CallFactory getCallFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.call.impl.TemplateCallImpl <em>Template Call</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.call.impl.TemplateCallImpl
     * @see org.emftext.language.templateconcepts.call.impl.CallPackageImpl#getTemplateCall()
     * @generated
     */
    EClass TEMPLATE_CALL = eINSTANCE.getTemplateCall();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference TEMPLATE_CALL__TARGET = eINSTANCE.getTemplateCall_Target();

    /**
     * The meta object literal for the '<em><b>Parameter Model</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference TEMPLATE_CALL__PARAMETER_MODEL = eINSTANCE.getTemplateCall_ParameterModel();

  }

} //CallPackage
