/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.templateconcepts.call.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.emftext.language.templateconcepts.Template;

import org.emftext.language.templateconcepts.call.CallPackage;
import org.emftext.language.templateconcepts.call.TemplateCall;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Template Call</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.emftext.language.templateconcepts.call.impl.TemplateCallImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link org.emftext.language.templateconcepts.call.impl.TemplateCallImpl#getParameterModel <em>Parameter Model</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TemplateCallImpl extends EObjectImpl implements TemplateCall
{
  /**
   * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTarget()
   * @generated
   * @ordered
   */
  protected Template target;

  /**
   * The cached value of the '{@link #getParameterModel() <em>Parameter Model</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParameterModel()
   * @generated
   * @ordered
   */
  protected EObject parameterModel;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TemplateCallImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return CallPackage.Literals.TEMPLATE_CALL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Template getTarget()
  {
    if (target != null && target.eIsProxy())
    {
      InternalEObject oldTarget = (InternalEObject)target;
      target = (Template)eResolveProxy(oldTarget);
      if (target != oldTarget)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallPackage.TEMPLATE_CALL__TARGET, oldTarget, target));
      }
    }
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Template basicGetTarget()
  {
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTarget(Template newTarget)
  {
    Template oldTarget = target;
    target = newTarget;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CallPackage.TEMPLATE_CALL__TARGET, oldTarget, target));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject getParameterModel()
  {
    if (parameterModel != null && parameterModel.eIsProxy())
    {
      InternalEObject oldParameterModel = (InternalEObject)parameterModel;
      parameterModel = eResolveProxy(oldParameterModel);
      if (parameterModel != oldParameterModel)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallPackage.TEMPLATE_CALL__PARAMETER_MODEL, oldParameterModel, parameterModel));
      }
    }
    return parameterModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject basicGetParameterModel()
  {
    return parameterModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParameterModel(EObject newParameterModel)
  {
    EObject oldParameterModel = parameterModel;
    parameterModel = newParameterModel;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, CallPackage.TEMPLATE_CALL__PARAMETER_MODEL, oldParameterModel, parameterModel));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case CallPackage.TEMPLATE_CALL__TARGET:
        if (resolve) return getTarget();
        return basicGetTarget();
      case CallPackage.TEMPLATE_CALL__PARAMETER_MODEL:
        if (resolve) return getParameterModel();
        return basicGetParameterModel();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case CallPackage.TEMPLATE_CALL__TARGET:
        setTarget((Template)newValue);
        return;
      case CallPackage.TEMPLATE_CALL__PARAMETER_MODEL:
        setParameterModel((EObject)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case CallPackage.TEMPLATE_CALL__TARGET:
        setTarget((Template)null);
        return;
      case CallPackage.TEMPLATE_CALL__PARAMETER_MODEL:
        setParameterModel((EObject)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case CallPackage.TEMPLATE_CALL__TARGET:
        return target != null;
      case CallPackage.TEMPLATE_CALL__PARAMETER_MODEL:
        return parameterModel != null;
    }
    return super.eIsSet(featureID);
  }

} //TemplateCallImpl
