/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.templateconcepts.call.resource.templatecall.grammar;

/**
 * This class provides the follow sets for all terminals of the grammar. These
 * sets are used during code completion.
 */
public class TemplatecallFollowSetProvider {
	
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallExpectedElement TERMINALS[] = new org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallExpectedElement[4];
	
	public final static org.eclipse.emf.ecore.EStructuralFeature[] FEATURES = new org.eclipse.emf.ecore.EStructuralFeature[0];
	
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallContainedFeature[] LINKS = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallContainedFeature[0];
	
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallContainedFeature[] EMPTY_LINK_ARRAY = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallContainedFeature[0];
	
	public static void initializeTerminals0() {
		TERMINALS[0] = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallExpectedCsString(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallGrammarInformationProvider.TEMPLATECALL_0_0_0_0);
		TERMINALS[1] = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallExpectedStructuralFeature(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallGrammarInformationProvider.TEMPLATECALL_0_0_0_1);
		TERMINALS[2] = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallExpectedCsString(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallGrammarInformationProvider.TEMPLATECALL_0_0_0_2);
		TERMINALS[3] = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallExpectedStructuralFeature(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallGrammarInformationProvider.TEMPLATECALL_0_0_0_3);
	}
	
	public static void initializeTerminals() {
		initializeTerminals0();
	}
	
	public static void initializeFeatures() {
	}
	
	public static void initializeLinks() {
	}
	
	public static void wire0() {
		TERMINALS[0].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[1].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[3], EMPTY_LINK_ARRAY);
	}
	
	public static void wire() {
		wire0();
	}
	
	static {
		// initialize the arrays
		initializeTerminals();
		initializeFeatures();
		initializeLinks();
		// wire the terminals
		wire();
	}
}
