/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.templateconcepts.call.resource.templatecall.mopp;

public class TemplatecallProblem implements org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallProblem {
	
	private String message;
	private org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemType type;
	private org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemSeverity severity;
	private java.util.Collection<org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallQuickFix> quickFixes;
	
	public TemplatecallProblem(String message, org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemType type, org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallQuickFix>emptySet());
	}
	
	public TemplatecallProblem(String message, org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemType type, org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemSeverity severity, org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public TemplatecallProblem(String message, org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemType type, org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemSeverity severity, java.util.Collection<org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemType getType() {
		return type;
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.TemplatecallEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
